
#include<gmp.h>
#include<stdio.h>

void __iters(int) __attribute__ ((__imarker()));

void mostlyHarmless(mpz_t out, mpz_t b, mpz_t e, mpz_t n)
{
/* Binary algorithm - slow'n'stupid */ 

int i;

for( i = 0, __iters(1024); i < 1024; i++)
{
	if ( mpz_tstbit(e,i) )
	{
		mpz_mul(out, out,out);
	}
	else
	{
		mpz_mul(out,out,b); 
	}
	mpz_mod(out, out, n); 
}};

int main(void)
{
  mpz_t base, exp, n, res;
  mpz_init_set_str (n, "929323829832", 10); 
  mpz_init_set_str (base, "292309832092", 10); 
  mpz_init_set_str (exp, "398230280832023",10); 
  mpz_init_set_ui(res,0);
  int j; 

for (j = 0, __iters(100000); j < 100000; j++)
	mostlyHarmless(res,base,exp,n); 

return 0; 
}
