.text
.align 4
.globl mul
mul:
	pushl     %edi
	pushl     %esi
	pushl     %ebp

	movzwl    16(%esp), %esi	# %esi = a
	movzwl    20(%esp), %ecx	# %ecx = b
	movl      %ecx, %edi		# %edi = b
	imull     %esi, %ecx		# %ecx = a * b
	movl      %ecx, %edx		# %edx = %ecx
	shrl      $16, %edx		# %edx >>= 16
	testl     %ecx, %ecx		# ZF = (p == 0)
	cmovnzw   %cx, %di		# if (ZF) %di = low16(p)
	cmovnzw   %dx, %si		# if (ZF) %si = p >> 16
	movl      %edi, %edx		# %edx = %edi
	xorl      %eax, %eax		# %eax = 0
	subl      %esi, %edx		# %edx -= %esi, GF = (%edx > %esi)
	setng     %al			# %al = GF
	addl      %edx, %eax		# %eax += %edx

	# An optimizing compiler could generate this code by boosting
	# the two branches of the nested `if', observing that either
	# a == 0 or b == 0 here so (a | b) equals the nonzero one, and
	# performing CSE.
	orl       %esi, %edi		# %edi |= %esi
	decl      %edi			# %edi--
	negl      %edi			# %edi = -%edi
	movl      %ecx, %edx		# %edx = %ecx
	testl     %ecx, %ecx		# ZF = (p == 0)
	cmovzl    %edi, %eax		# if (ZF) %eax = %edi

	popl      %ebp
	popl      %esi
	popl      %edi
	ret
