#include <stdio.h>
#include <time.h>

#define KEYSIZE 16	 /* size of key, in bytes */
typedef unsigned int WORD; /* Should be 32-bit = 4 bytes        */

typedef enum { ShiftLeft, ShiftRight } ShiftDir;


typedef enum { KeyWords = KEYSIZE / 4,
	       NumRounds = 15,  /* Number of cryptographic rounds  */
	       TableSize = 32   /* size of table = 2 * (NumRounds + 1) */
} bogus;


WORD Table[ TableSize ];
WORD L[KeyWords]; 



WORD ROT(const WORD x, const WORD y, const ShiftDir dir);
void SetKey( unsigned char KeyChar );
void encrypt(WORD *PlainText, WORD *CryptoText);
void decrypt(WORD *CryptoText, WORD *PlainText);
void setup();

/*
   Testbench for crytography algorithm
 */
int main(void)
{ 
  WORD i, j;
  WORD PlainText1[2], PlainText2[2];
  WORD CryptoText[2] = {0,0};
  time_t t0, t1;
  char *keystr = "TheQuickBrownFox";

  if (sizeof(WORD)!=4) 
    printf("RC5 error: WORD has %d bytes.\n",sizeof(WORD));

  printf("RC5-32/12/16 examples:\n");
  for (i = 1; i<6; i++)
    { 
      PlainText1[0] = CryptoText[0]; 
      PlainText1[1] = CryptoText[1]; 
      for (j=0; j < KEYSIZE; j++) 
         SetKey((unsigned char)keystr[j]);
      /* Setup, encrypt, and decrypt */
      setup();  
      encrypt(PlainText1,CryptoText);  
      decrypt(CryptoText,PlainText2);

      /* Print out results, checking for decryption failure */
      printf("\n   plaintext %.8lX %.8lX  --->  ciphertext %.8lX %.8lX\n",
             PlainText1[0], PlainText1[1], CryptoText[0], CryptoText[1]);
      if (PlainText1[0]!=PlainText2[0] || PlainText1[1]!=PlainText2[1]) 
        printf("Decryption Error!");
    }
  time (&t0);
  for (i=1;i<5000000;i++)
     encrypt(CryptoText,CryptoText);
  time (&t1);
  printf ("\n   Time_t for 5000000 blocks:  %ld \n", t1-t0);
 return(0);
}

