// $Id: fastrol-mod.c,v 1.1 2005/05/08 19:31:05 dmolnar Exp $

/*									tab:4
 * "Copyright (c) 2000-2003 The Regents of the University  of California.  
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose, without fee, and without written agreement is
 * hereby granted, provided that the above copyright notice, the following
 * two paragraphs and the author appear in all copies of this software.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY FOR
 * DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES ARISING OUT
 * OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF
 * CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS
 * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
 * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS."
 *
 * Copyright (c) 2002-2003 Intel Corporation
 * All rights reserved.
 *
 * This file is distributed under the terms in the attached INTEL-LICENSE     
 * file. If you do not find these files, copies can be found by writing to
 * Intel Research Berkeley, 2150 Shattuck Avenue, Suite 1300, Berkeley, CA, 
 * 94704.  Attention:  Intel License Inquiry.
 */

/* Authors: Naveen Sastry
 * Date:    9/29/02
 */

/**
 * @author Naveen Sastry
 */

#include <stdio.h>
#include "crypto.h"
#include "CryptoPrimitives.h"
//includes crypto;

#define RC5_32_P	0xB7E15163L
#define RC5_32_Q	0x9E3779B9L
#define RC5_32_MASK	0xffffffffL

#define RC5_ROUNDS 12

#define rotl32(a,b) fastrol32((a), (b))
#define rotr32(a,b) fastror32((a), (b))

//module RC5M {
//  provides interface BlockCipher;
//  provides interface BlockCipherInfo;
//}
//implementation
//{

  #define result_t uint32_t
  #define SUCCESS 1
  #define FAIL 0

  uint32_t rotate_left32(uint32_t a, uint8_t n) {
	return (((a)<<(n&0x1f))|(((a)&0xffffffff)>>(32-(n&0x1f)))); 
  }

  uint32_t rotate_right32(uint32_t a, uint8_t n) {
	return (((a)<<(32-(n&0x1f)))|(((a)&0xffffffff)>>(n&0x1f)));
  }

  uint32_t fastrol32(uint32_t a, uint8_t n) {
    n = n & 0x1f;
    if ((n) == 0) {
	return a;
    }
    if ((n) >= 1 && (n) <= 5) {
        return rol32(a, (n));
    }
    if ((n) >= 6 && (n) <= 7) {
        a = brol1(a);
        return ror32(a, 8-(n));
    } 
    if ((n) >= 8 && (n) <= 12) {
        a = brol1(a);
        return ror32(a, (n)-8);
    }
     if ((n) >= 13 && (n) <= 16) {
        a = brol2(a);
        return ror32(a, 16-(n));
    }
     if ((n) >= 17 && (n) <= 20) {
        a = brol2(a);
        return rol32(a, (n)-16);
    }
     if ((n) >= 21 && (n) <= 24) {
        a = brol3(a);
        return ror32(a, 24-(n));
    } 
     if ((n) >= 25 && (n) <= 28) {
        a = brol3(a);
        return ror32(a, (n)-24);
    }
      if ((n) >= 29 && (n) <= 31) {
        return ror32(a, 32-(n));
    }
    return 0; 
  }

    


