import java.util.*;

/**
 * A set of register or memory locations.
 */
class LocationSet extends HashSet<DataValue> implements Cloneable {

    protected DataValue lastMemOp;

    LocationSet() {
	super();
    }

    LocationSet(int initialSize) {
	super(initialSize);
    }

    public Object clone() {
	LocationSet newSet = (LocationSet)super.clone();
	newSet.lastMemOp = lastMemOp;
	return newSet;
    }

    public DataValue getLastMemOp() {
	return lastMemOp;
    }

    public void setLastMemOp(DataValue v) {
	lastMemOp = v;
    }

    /**
     * Remove from this set all memory references.
     */
    public void flushMemory() {
	LinkedList<DataValue> toBeRemoved = new LinkedList<DataValue>();
	for (DataValue v : this) {
	    if (v.getType() == DataValue.locType.MEM)
		toBeRemoved.add(v);
	}
	Debug.println(3, "tainting memory: " + toBeRemoved);
	for (DataValue v : toBeRemoved)
	    remove(v);
    }

}
